VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPOP3Check"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'storage for properties
Private m_Username As String
Private m_Password As String
Private m_ServerHost As String
Private m_ServerPort As String
Private m_NewMessages As Integer

Dim WithEvents m_Socket As Winsock
Attribute m_Socket.VB_VarHelpID = -1

'events
Public Event Status(StatusCode As EMCStatus, StatusDesc As String)
Public Event Error(ErrorCode As EMCError, ErrorDesc As String)

'private data
Private iLastAction As EMCStatus    'last command sent
'Error Codes
Public Sub AttachSocket(WinsockControl As Winsock)
Set m_Socket = WinsockControl
End Sub
Private Sub eventError(ErrorCode As EMCError, Optional ErrorDesc As String = "")
'If ErrorDesc = "" Then
'    RaiseEvent Error(ErrorCode, GetErrorDesc(ErrorCode))
'Else
    RaiseEvent Error(ErrorCode, ErrorDesc)
'End If
End Sub
Private Sub eventStatus(StatusCode As EMCStatus, Optional StatusDesc As String = "")
iLastAction = StatusCode
If StatusDesc = "" Then
    RaiseEvent Status(StatusCode, GetStatusDesc(StatusCode))
Else
    RaiseEvent Status(StatusCode, StatusDesc)
End If
End Sub
Public Sub Execute()

'check if socket attached
If m_Socket Is Nothing Then
    eventError eMCError_NoSocket
    Exit Sub
End If

'check if username/pass/server set
If m_Username = "" Then
    eventError eMCError_NoUsername
    Exit Sub
End If

If m_Password = "" Then
    eventError eMCError_NoPassword
    Exit Sub
End If

If m_ServerHost = "" Then
    eventError eMCError_NoServerHost
    Exit Sub
End If

'reset socket
ResetSocket

eventStatus eMCStatus_Connecting

m_Socket.RemoteHost = m_ServerHost
m_Socket.RemotePort = m_ServerPort
m_Socket.Connect
End Sub
Public Property Get NewMessages() As Integer
NewMessages = m_NewMessages
End Property
Private Function ResetSocket()
With m_Socket
    .Close
    .Protocol = sckTCPProtocol
End With
End Function
Public Property Let ServerHost(m As String)
m_ServerHost = m
End Property
Public Property Get ServerHost() As String
ServerHost = m_ServerHost
End Property
Public Property Let ServerPort(m As Long)
m_ServerPort = m
End Property
Public Property Get ServerPort() As Long
ServerPort = m_ServerPort
End Property
Public Sub SetLogin(User As String, Pass As String)
m_Username = User
m_Password = Pass
End Sub
Public Sub SetServer(ServerHost As String, Optional ServerPort As Long = 110)
m_ServerHost = ServerHost
m_ServerPort = ServerPort
End Sub
Public Property Let Username(m As String)
m_Username = Trim$(m)
End Property
Public Property Let Password(m As String)
m_Password = Trim$(m)
End Property
Public Property Get Password() As String
Password = m_Password
End Property
Public Property Set Socket(m As Winsock)
Set m_Socket = m
End Property
Public Property Get Socket() As Winsock
Set Socket = m_Socket
End Property
Public Property Get Username() As String
Username = m_Username
End Property
Private Sub Class_Initialize()
m_ServerPort = 110
End Sub
Private Sub m_Socket_DataArrival(ByVal bytesTotal As Long)

'data is sent from pop3 server as:
'  +OK <data>
'  -ERR <data>

Dim sData As String, bOK As Boolean
Debug.Assert (m_Socket.State = 7)
m_Socket.GetData sData ', vbString, bytesTotal

If Right(sData, 2) = vbCrLf Then sData = Mid(sData, 1, Len(sData) - 2)

bOK = (Left(sData, 1) = "+")
sData = Mid$(sData, InStr(1, sData, " ") + 1)

'Clipboard.SetText sInData

Select Case iLastAction
    Case eMCStatus_Connecting
        'if ok, send username
        If bOK Then
            eventStatus eMCStatus_POP_USER
            m_Socket.SendData "USER " & m_Username & vbCrLf
        Else
            eventError eMCError_Unknown, sData
        End If
        
    Case eMCStatus_POP_USER
        'username sent, if ok, send password
        If bOK Then
            eventStatus eMCStatus_POP_PASS
            m_Socket.SendData "PASS " & m_Password & vbCrLf
        Else
            eventError eMCError_Unknown, sData
        End If
        
    Case eMCStatus_POP_PASS
        'password sent, if ok, send stat
        If bOK Then
            eventStatus eMCStatus_POP_STAT
            m_Socket.SendData "STAT" & vbCrLf
        Else
            eventError eMCError_Unknown, sData
        End If
        
    Case eMCStatus_POP_STAT
        'stat sent, if ok, parse retval
        'data is sent as NUM-MSGS
        If bOK Then
            m_NewMessages = Mid(sData, 1, InStr(sData, " ") - 1)
            eventStatus eMCStatus_Success
            ResetSocket
        Else
            eventError eMCError_Unknown, sData
        End If
End Select
End Sub
Public Sub Cancel()
m_Socket.Close
End Sub

Private Sub m_Socket_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
eventError CVar(Number), Description
End Sub
