VERSION 5.00
Begin VB.UserControl ControlFrame 
   ClientHeight    =   495
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   570
   ControlContainer=   -1  'True
   ScaleHeight     =   495
   ScaleWidth      =   570
   ToolboxBitmap   =   "ControlFrame.ctx":0000
End
Attribute VB_Name = "ControlFrame"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'=======================================================================
'- Project: vboControlFrame
'- Author: Jared Hoylman
'- Copyright  1999 Jared Hoylman
'- Provided By: VB Overdrive
'- URL: http://www.extreme-vb.net/vboverdrive/
'=======================================================================

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

'DrawFrameControl Types:
Private Const DFC_BUTTON& = 4
Private Const DFC_CAPTION& = 1
Private Const DFC_MENU& = 2
Private Const DFC_SCROLL& = 3

'DrawFrameControl Styles:
Private Const DFCS_ADJUSTRECT = &H2000
Private Const DFCS_BUTTON3STATE& = &H8
Private Const DFCS_BUTTONCHECK& = &H0
Private Const DFCS_BUTTONPUSH = &H10
Private Const DFCS_BUTTONRADIO& = &H4
Private Const DFCS_BUTTONRADIOIMAGE& = &H1
Private Const DFCS_BUTTONRADIOMASK& = &H2
Private Const DFCS_CAPTIONCLOSE& = &H0
Private Const DFCS_CAPTIONHELP& = &H4
Private Const DFCS_CAPTIONMAX& = &H2
Private Const DFCS_CAPTIONMIN& = &H1
Private Const DFCS_CAPTIONRESTORE& = &H3
Private Const DFCS_CHECKED& = &H400
Private Const DFCS_FLAT& = &H4000
Private Const DFCS_INACTIVE& = &H100
Private Const DFCS_MENUARROW& = &H0
Private Const DFCS_MENUARROWRIGHT& = &H4
Private Const DFCS_MENUBULLET& = &H2
Private Const DFCS_MENUCHECK& = &H1
Private Const DFCS_MONO& = &H8000&
Private Const DFCS_PUSHED& = &H200
Private Const DFCS_SCROLLCOMBOBOX& = &H5
Private Const DFCS_SCROLLDOWN& = &H1
Private Const DFCS_SCROLLLEFT& = &H2
Private Const DFCS_SCROLLRIGHT& = &H3
Private Const DFCS_SCROLLSIZEGRIP& = &H8
Private Const DFCS_SCROLLSIZEGRIPRIGHT& = &H10
Private Const DFCS_SCROLLUP& = &H0

'==========================================================
'- Win32 API Functions
'==========================================================

Private Declare Function GetClientRect& Lib "user32" (ByVal hwnd As Long, lpRect As RECT)
Private Declare Function DrawFrameControl& Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal un1 As Long, ByVal un2 As Long)
Private Declare Function DrawFocusRect& Lib "user32" (ByVal hdc As Long, lpRect As RECT)
Private Declare Function InflateRect& Lib "user32" (lpRect As RECT, ByVal X As Long, ByVal Y As Long)


'==========================================================
'- Project Enums
'==========================================================

'Style Enum:
Public Enum FC_STYLE
    Button
    Caption
    Menu
    Scroll
End Enum

'ButtonStyle Enum:
Public Enum FC_BS
    BS_Push
    BS_Check
    BS_ThreeState
    BS_Radio
    BS_RadioImage
    BS_RadioMask
End Enum

'MenuStyle Enum:
Public Enum FC_MS
    MS_Arrow
    MS_ArrowRight
    MS_Bullet
    MS_Check
End Enum

'CaptionStyle Enum:
Public Enum FC_CS
    CS_Close
    CS_Help
    CS_Min
    CS_Max
    CS_Restore
End Enum

'ScrollStyle Enum:
Public Enum FC_SS
    SS_Up
    SS_Down
    SS_Left
    SS_Right
    SS_ComboBox
    SS_SizeGrip
    SS_SizeGripRight
End Enum


'==========================================================
'- Project Variables
'==========================================================

'Default Property Values:
Const m_def_AutoFocusRect = False
Const m_def_FocusRect = False
Const m_def_AutoPush = False
Const m_def_ButtonStyle = 0
Const m_def_MenuStyle = 0
Const m_def_CaptionStyle = 0
Const m_def_ScrollStyle = 0
Const m_def_Flat = False
Const m_def_Inactive = False
Const m_def_Checked = False
Const m_def_Mono = False
Const m_def_Pushed = False
Const m_def_Style = Button

'Property Variables:
Dim m_AutoFocusRect As Boolean
Dim m_FocusRect As Boolean
Dim m_AutoPush As Boolean
Dim m_Style  As FC_STYLE
Dim m_ButtonStyle As FC_BS
Dim m_MenuStyle As FC_MS
Dim m_CaptionStyle As FC_CS
Dim m_ScrollStyle As FC_SS
Dim m_Flat As Boolean
Dim m_Inactive As Boolean
Dim m_Checked As Boolean
Dim m_Mono As Boolean
Dim m_Pushed As Boolean

'==========================================================
'- Events
'==========================================================
    
'Event Declarations:
Event Click()
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

Public Property Get Flat() As Boolean
Attribute Flat.VB_Description = "Returns/Sets if FrameControl isflat."
    Flat = m_Flat
End Property

Public Property Let Flat(ByVal New_Flat As Boolean)
    m_Flat = New_Flat
    Redraw
    PropertyChanged "Flat"
End Property

Public Property Get Inactive() As Boolean
Attribute Inactive.VB_Description = "Returns/Sets if FrameControl is inactive."
    Inactive = m_Inactive
End Property

Public Property Let Inactive(ByVal New_Inactive As Boolean)
    m_Inactive = New_Inactive
    Redraw
    PropertyChanged "Inactive"
End Property

Public Property Get Checked() As Boolean
Attribute Checked.VB_Description = "Returns/Sets if FrameControl is checked."
    Checked = m_Checked
End Property

Public Property Let Checked(ByVal New_Checked As Boolean)
    m_Checked = New_Checked
    Redraw
    PropertyChanged "Checked"
End Property

Public Property Get Mono() As Boolean
Attribute Mono.VB_Description = "Returns/Sets if FrameControl is mono."
    Mono = m_Mono
End Property

Public Property Let Mono(ByVal New_Mono As Boolean)
    m_Mono = New_Mono
    Redraw
    PropertyChanged "Mono"
End Property

Public Property Get Pushed() As Boolean
Attribute Pushed.VB_Description = "Returns/Sets if FrameControl is pushed."
    Pushed = m_Pushed
End Property

Public Property Let Pushed(ByVal New_Pushed As Boolean)
    m_Pushed = New_Pushed
    Redraw
    PropertyChanged "Pushed"
End Property

Private Sub UserControl_Click()
    RaiseEvent Click
End Sub

Public Property Get Style() As FC_STYLE
    Style = m_Style
End Property

Public Property Let Style(ByVal New_Style As FC_STYLE)
    m_Style = New_Style
    Redraw
    PropertyChanged "Style"
End Property

Public Property Get ButtonStyle() As FC_BS
    ButtonStyle = m_ButtonStyle
End Property

Public Property Let ButtonStyle(ByVal New_ButtonStyle As FC_BS)
    m_ButtonStyle = New_ButtonStyle
    Redraw
    PropertyChanged "ButtonStyle"
End Property

Public Property Get MenuStyle() As FC_MS
    MenuStyle = m_MenuStyle
End Property

Public Property Let MenuStyle(ByVal New_MenuStyle As FC_MS)
    m_MenuStyle = New_MenuStyle
    Redraw
    PropertyChanged "MenuStyle"
End Property

Public Property Get CaptionStyle() As FC_CS
    CaptionStyle = m_CaptionStyle
End Property

Public Property Let CaptionStyle(ByVal New_CaptionStyle As FC_CS)
    m_CaptionStyle = New_CaptionStyle
    Redraw
    PropertyChanged "CaptionStyle"
End Property

Public Property Get ScrollStyle() As FC_SS
    ScrollStyle = m_ScrollStyle
End Property

Public Property Let ScrollStyle(ByVal New_ScrollStyle As FC_SS)
    m_ScrollStyle = New_ScrollStyle
    Redraw
    PropertyChanged "ScrollStyle"
End Property

Public Property Get AutoPush() As Boolean
    AutoPush = m_AutoPush
End Property

Public Property Let AutoPush(ByVal New_AutoPush As Boolean)
    m_AutoPush = New_AutoPush
    PropertyChanged "AutoPush"
End Property

Public Property Get FocusRect() As Boolean
    FocusRect = m_FocusRect
End Property

Public Property Let FocusRect(ByVal New_FocusRect As Boolean)
    m_FocusRect = New_FocusRect
    Redraw
    PropertyChanged "FocusRect"
End Property

Public Property Get AutoFocusRect() As Boolean
    AutoFocusRect = m_AutoFocusRect
End Property

Public Property Let AutoFocusRect(ByVal New_AutoFocusRect As Boolean)
    m_AutoFocusRect = New_AutoFocusRect
    PropertyChanged "AutoFocusRect"
End Property

Private Sub UserControl_GotFocus()
If m_AutoFocusRect = True Then m_FocusRect = True
Redraw
End Sub

Private Sub UserControl_LostFocus()
If m_AutoFocusRect = True Then m_FocusRect = False
Redraw
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If m_AutoPush = True Then Pushed = True
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    'Check for Auto Push and Push if True
    If m_AutoPush = True Then Pushed = False
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    'Check for Auto Push and Un-Push if True
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

'Initialize Properties for User Control:
Private Sub UserControl_InitProperties()
    m_Flat = m_def_Flat
    m_Inactive = m_def_Inactive
    m_Checked = m_def_Checked
    m_Mono = m_def_Mono
    m_Pushed = m_def_Pushed
    m_Style = m_def_Style
    m_ButtonStyle = m_def_ButtonStyle
    m_MenuStyle = m_def_MenuStyle
    m_CaptionStyle = m_def_CaptionStyle
    m_ScrollStyle = m_def_ScrollStyle
    m_AutoPush = m_def_AutoPush
    m_FocusRect = m_def_FocusRect
    m_AutoFocusRect = m_def_AutoFocusRect
End Sub

Private Sub UserControl_Paint()
Redraw
End Sub

'Load property values from storage:
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    m_Flat = PropBag.ReadProperty("Flat", m_def_Flat)
    m_Inactive = PropBag.ReadProperty("Inactive", m_def_Inactive)
    m_Checked = PropBag.ReadProperty("Checked", m_def_Checked)
    m_Mono = PropBag.ReadProperty("Mono", m_def_Mono)
    m_Pushed = PropBag.ReadProperty("Pushed", m_def_Pushed)
    m_Style = PropBag.ReadProperty("Style", m_def_Style)
    m_ButtonStyle = PropBag.ReadProperty("ButtonStyle", m_def_ButtonStyle)
    m_MenuStyle = PropBag.ReadProperty("MenuStyle", m_def_MenuStyle)
    m_CaptionStyle = PropBag.ReadProperty("CaptionStyle", m_def_CaptionStyle)
    m_ScrollStyle = PropBag.ReadProperty("ScrollStyle", m_def_ScrollStyle)
    m_AutoPush = PropBag.ReadProperty("AutoPush", m_def_AutoPush)
    m_FocusRect = PropBag.ReadProperty("FocusRect", m_def_FocusRect)
    m_AutoFocusRect = PropBag.ReadProperty("AutoFocusRect", m_def_AutoFocusRect)
End Sub

'Write property values to storage:
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("Flat", m_Flat, m_def_Flat)
    Call PropBag.WriteProperty("Inactive", m_Inactive, m_def_Inactive)
    Call PropBag.WriteProperty("Checked", m_Checked, m_def_Checked)
    Call PropBag.WriteProperty("Mono", m_Mono, m_def_Mono)
    Call PropBag.WriteProperty("Pushed", m_Pushed, m_def_Pushed)
    Call PropBag.WriteProperty("Style", m_Style, m_def_Style)
    Call PropBag.WriteProperty("ButtonStyle", m_ButtonStyle, m_def_ButtonStyle)
    Call PropBag.WriteProperty("MenuStyle", m_MenuStyle, m_def_MenuStyle)
    Call PropBag.WriteProperty("CaptionStyle", m_CaptionStyle, m_def_CaptionStyle)
    Call PropBag.WriteProperty("ScrollStyle", m_ScrollStyle, m_def_ScrollStyle)
    Call PropBag.WriteProperty("AutoPush", m_AutoPush, m_def_AutoPush)
    Call PropBag.WriteProperty("FocusRect", m_FocusRect, m_def_FocusRect)
    Call PropBag.WriteProperty("AutoFocusRect", m_AutoFocusRect, m_def_AutoFocusRect)
End Sub

Private Sub Redraw()
'Declarations:
Dim rRect As RECT
Dim lStyle As Long
Dim lProp As Long
Dim hdc As Long
Dim hwnd As Long

'Get DC and hWnd of UserControl for later:
hdc = UserControl.hdc
hwnd = UserControl.hwnd

'Select Style:
Select Case m_Style
    
    Case Button
        'If Button then set style to Button
        lStyle = DFC_BUTTON
            'Select ButtonStyle
            Select Case m_ButtonStyle
                Case BS_Push
                    lProp = DFCS_BUTTONPUSH
                Case BS_Check
                    lProp = DFCS_BUTTONCHECK
                Case BS_ThreeState
                    lProp = DFCS_BUTTON3STATE
                Case BS_Radio
                    lProp = DFCS_BUTTONRADIO
                Case BS_RadioImage
                    lProp = DFCS_BUTTONRADIOIMAGE
                Case BS_RadioMask
                    lProp = DFCS_BUTTONRADIOMASK
            End Select
            
    Case Caption
        'If Caption then set style to Caption
        lStyle = DFC_CAPTION
            'Select CaptionStyle
            Select Case m_CaptionStyle
                Case CS_Close
                    lProp = DFCS_CAPTIONCLOSE
                Case CS_Help
                    lProp = DFCS_CAPTIONHELP
                Case CS_Min
                    lProp = DFCS_CAPTIONMIN
                Case CS_Max
                    lProp = DFCS_CAPTIONMAX
                Case CS_Restore
                    lProp = DFCS_CAPTIONRESTORE
            End Select
                
    Case Menu
        'If Menu then set style to Menu
        lStyle = DFC_MENU
            'Select MenuStyle
            Select Case m_MenuStyle
                Case MS_Arrow
                    lProp = DFCS_MENUARROW
                Case MS_ArrowRight
                    lProp = DFCS_MENUARROWRIGHT
                Case MS_Bullet
                    lProp = DFCS_MENUBULLET
                Case MS_Check
                    lProp = DFCS_MENUCHECK
            End Select
            
    Case Scroll
        'If Scroll then set style to Scroll
        lStyle = DFC_SCROLL
            'Select ScrollStyle
            Select Case m_ScrollStyle
                Case SS_Up
                    lProp = DFCS_SCROLLUP
                Case SS_Down
                    lProp = DFCS_SCROLLDOWN
                Case SS_Left
                    lProp = DFCS_SCROLLLEFT
                Case SS_Right
                    lProp = DFCS_SCROLLRIGHT
                Case SS_ComboBox
                    lProp = DFCS_SCROLLCOMBOBOX
                Case SS_SizeGrip
                    lProp = DFCS_SCROLLSIZEGRIP
                Case SS_SizeGripRight
                    lProp = DFCS_SCROLLSIZEGRIPRIGHT
            End Select
End Select

'Select Other Property Values
If (m_Flat = True) Then lProp = lProp Or DFCS_FLAT
If (m_Inactive = True) Then lProp = lProp Or DFCS_INACTIVE
If (m_Mono = True) Then lProp = lProp Or DFCS_MONO
If (m_Pushed = True) Then lProp = lProp Or DFCS_PUSHED
If (m_Checked = True) Then lProp = lProp Or DFCS_CHECKED
lProp = lProp Or DFCS_ADJUSTRECT

'Get UserControl's Rectangle
GetClientRect hwnd, rRect

'Clear UserControl
UserControl.Cls

'Draw Frame Control with selected styles and properties
DrawFrameControl hdc, rRect, lStyle, lProp

'If FocusRect = True then draw Focus rectangle
If m_FocusRect = True Then
    'Adjust rRect for Focus Rectangle
    InflateRect rRect, -2, -2
    'Draw Focus rectangle
    DrawFocusRect hdc, rRect
End If

End Sub





