Attribute VB_Name = "MMailCheck"
Option Explicit

Public Enum EMCServerType
    eMC_ServerType_NotAssigned = 0
    eMC_ServerType_POP3
    eMC_ServerType_Hotmail
End Enum

Public Enum EMCError
    eMCError_NoError = 0
    eMCError_NoServerType
    eMCError_NoServerHost
    eMCError_NoServerPort
    eMCError_NoUsername
    eMCError_NoPassword
    eMCError_NoSocket
    eMCError_BadPassword
    eMCError_Disconnected
    eMCError_Unknown = -1
End Enum

Public Enum EMCStatus
    'general constants
    eMCStatus_Unknown = -1
    eMCStatus_Connecting = 1
    eMCStatus_Success = 99
    
    'pop3 constants
    eMCStatus_POP_USER = 101
    eMCStatus_POP_PASS
    eMCStatus_POP_STAT
    eMCStatus_POP_QUIT
        
    'hotmail constants
    eMCStatus_HM_SendingLogin = 201
    eMCStatus_HM_FindingServer
    eMCStatus_HM_RequestingMailbox
    eMCStatus_HM_ProcessingMailbox
End Enum

Public Enum EMCEvent
    eMCEvent_Error = 1
    eMCEvent_Status = 2
End Enum
Public Function GetErrorDesc(ErrorCode As EMCError) As String
Select Case ErrorCode
    Case eMCError_NoError
        GetErrorDesc = "No Error"
    Case eMCError_NoServerType
        GetErrorDesc = "No Server Type"
    Case eMCError_NoServerHost
        GetErrorDesc = "No Server Host"
    Case eMCError_NoServerPort
        GetErrorDesc = "No Server Port"
    Case eMCError_NoUsername
        GetErrorDesc = "No Username"
    Case eMCError_NoPassword
        GetErrorDesc = "No Password"
    Case eMCError_BadPassword
        GetErrorDesc = "Invalid Password"
    Case eMCError_NoSocket
        GetErrorDesc = "No Socket"
    Case eMCError_Unknown
        GetErrorDesc = "Unknown Error"
End Select
End Function
Public Function GetStatusDesc(StatusCode As EMCStatus) As String
Select Case StatusCode
    Case eMCStatus_Unknown
        GetStatusDesc = "Unknown status"
    Case eMCStatus_Connecting
        GetStatusDesc = "Connecting"
    Case eMCStatus_Success
        GetStatusDesc = "Success"
        
    'pop3 status
    Case eMCStatus_POP_USER
        GetStatusDesc = "Sending Username"
    Case eMCStatus_POP_PASS
        GetStatusDesc = "Sending Password"
    Case eMCStatus_POP_STAT
        GetStatusDesc = "Retrieving Message Count"
    Case eMCStatus_POP_QUIT
        GetStatusDesc = "Logging out"
        
    'hotmail status
    Case eMCStatus_HM_SendingLogin
        GetStatusDesc = "Sending Login"
    Case eMCStatus_HM_FindingServer
        GetStatusDesc = "Finding Server"
    Case eMCStatus_HM_RequestingMailbox
        GetStatusDesc = "Requesting Mailbox"
    Case eMCStatus_HM_ProcessingMailbox
        GetStatusDesc = "Processing Mailbox"
End Select
End Function
