Attribute VB_Name = "MSettings"
Option Explicit

Private Settings As CSettings

Private Const SETTINGSFILE = "settings.ini"

Public Enum ESetting
    eSET_RegisteredName
    eSET_RegisteredEmail
    eSET_RegisteredSerial
    eSET_CheckDelay
    eSET_VisualNotification
    eSET_AuralNotification
    eSET_AutoHide
    eSET_ShowPassword
End Enum
Public Function GetSetting(Setting As ESetting)
GetSetting = ValidateSetting(Setting, Settings.GetSetting(GetSettingName(Setting), GetSettingDefault(Setting)))
End Function
Private Function GetSettingName(Setting As ESetting)
Select Case Setting
    Case eSET_RegisteredName
        GetSettingName = "RegisteredName"
    Case eSET_RegisteredEmail
        GetSettingName = "RegisteredEmail"
    Case eSET_RegisteredSerial
        GetSettingName = "RegisteredSerial"
    Case eSET_CheckDelay
        GetSettingName = "CheckDelay"
    Case eSET_VisualNotification
        GetSettingName = "VisualNotify"
    Case eSET_AuralNotification
        GetSettingName = "AuralNotify"
    Case eSET_AutoHide
        GetSettingName = "AutoHide"
    Case eSET_ShowPassword
        GetSettingName = "ShowPassword"
'    Case Setting =
    Case Else
        ReportBug "GetSettingName", "Unknown setting requested: " & Setting
End Select
End Function
Private Function GetSettingDefault(Setting As ESetting)
Select Case Setting
    Case eSET_RegisteredName, eSET_RegisteredEmail, eSET_RegisteredSerial
        GetSettingDefault = ""
    Case eSET_CheckDelay
        GetSettingDefault = 5
    Case eSET_VisualNotification
        GetSettingDefault = 1
    Case eSET_AuralNotification, eSET_AutoHide, eSET_ShowPassword
        GetSettingDefault = 0
    Case Else
        ReportBug "GetSettingDefault", "Unknown setting requested: " & Setting
End Select
End Function
Public Sub LoadSettings()

Set Settings = New CSettings

With Settings
    .Filename = joinFilePath(App.Path, SETTINGSFILE)
    .LoadSettings
End With
End Sub
Public Sub SaveSetting(Setting As ESetting, SettingValue)
Settings.AddSetting GetSettingName(Setting), SettingValue
End Sub
Public Sub SaveSettings()
With Settings
    .SaveSettings
End With
End Sub
Private Function ValidateSetting(Setting As ESetting, SettingValue)
'verifies is setting is in correct format, if not sets to default

ValidateSetting = SettingValue

Select Case Setting
    Case eSET_CheckDelay
        On Error Resume Next
        ValidateSetting = Int(SettingValue)
        If Err Then ValidateSetting = GetSettingDefault(Setting)
        On Error GoTo 0
    Case eSET_AuralNotification, eSET_VisualNotification, eSET_AutoHide, eSET_ShowPassword
        If (SettingValue <> 0) And (SettingValue <> 1) Then ValidateSetting = GetSettingDefault(Setting)
    Case eSET_RegisteredName, eSET_RegisteredSerial, eSET_RegisteredEmail
        ValidateSetting = SettingValue
    Case Else
        ReportBug "ValidateSetting", "Unknown setting requested: " & Setting
End Select
End Function
