VERSION 5.00
Begin VB.UserControl Titlebar 
   Alignable       =   -1  'True
   CanGetFocus     =   0   'False
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ControlContainer=   -1  'True
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "Titlebar.ctx":0000
End
Attribute VB_Name = "Titlebar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'Event Declarations:
Event Resize() 'MappingInfo=UserControl,UserControl,-1,Resize
Attribute Resize.VB_Description = "Occurs when a form is first displayed or the size of an object changes."
Event Click() 'MappingInfo=UserControl,UserControl,-1,Click
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event DblClick() 'MappingInfo=UserControl,UserControl,-1,DblClick
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseDown
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseMove
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseUp
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."

Public Enum ETBCaptionBegin
    etbcb_Automatic = 0
    etbcb_Manual = 1
End Enum

'move routines
Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Type POINTAPI
   X As Long
   Y As Long
End Type

Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function DrawFocusRect Lib "user32" (ByVal hdc As Long, lpRect As RECT) As Long
Private Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Private Declare Function GetCurrentPositionEx Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long

Dim tpoint As POINTAPI
Dim Temp   As POINTAPI
Dim dpoint As POINTAPI

Dim fbox   As RECT
Dim tbox   As RECT
Dim oldbox As RECT

Dim TwipsPerPixelX
Dim TwipsPerPixelY

'caption routines
Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal nHeight As Long, ByVal nWidth As Long, ByVal nEscapement As Long, ByVal nOrientation As Long, ByVal fnWeight As Long, ByVal fdwItalic As Long, ByVal fdwUnderline As Long, ByVal fdwStrikeout As Long, ByVal fdwCharset As Long, ByVal fdwOutputPrecision As Long, ByVal fdwClipPrecision As Long, ByVal fdwQuality As Long, ByVal fdwPitchAndFamily As Long, ByVal lpszFace As String) As Long
Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function MulDiv Lib "kernel32" (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long

Private Const LOGPIXELSY = 90        '  Logical pixels/inch in Y

'nHeight, nWidth: maximum height/width of font
'nEscapement, nOrientation: rotation in tenths of degrees
'fnWeight: Weight from 0 to 1000
'fdwItalic, fdwUnderline, fdwStrikeOut: bool
'fdwCharSet: character set
'fdwOutputPrecision: output precision
'fdwClipPrecision: clip precision
'fdwQuality: output quality
'fdwPitchAndFamily: pitch and family
'lpszFace: font name

'fnWeight constants
Const FW_DONTCARE = 0
Const FW_THIN = 100
Const FW_EXTRALIGHT = 200
Const FW_ULTRALIGHT = 200
Const FW_LIGHT = 300
Const FW_NORMAL = 400
Const FW_REGULAR = 400
Const FW_MEDIUM = 500
Const FW_SEMIBOLD = 600
Const FW_DEMIBOLD = 600
Const FW_BOLD = 700
Const FW_EXTRABOLD = 800
Const FW_ULTRABOLD = 800
Const FW_HEAVY = 900
Const FW_BLACK = 900

'fdwCharSet constants
Const ANSI_CHARSET = 0
Const DEFAULT_CHARSET = 1
Const SYMBOL_CHARSET = 2
Const SHIFTJIS_CHARSET = 128
Const HANGEUL_CHARSET = 129
Const HANGUL_CHARSET = 129
Const GB2312_CHARSET = 134
Const CHINESEBIG5_CHARSET = 136
Const OEM_CHARSET = 255
Const JOHAB_CHARSET = 130
Const HEBREW_CHARSET = 177
Const ARABIC_CHARSET = 178
Const GREEK_CHARSET = 161
Const TURKISH_CHARSET = 162
Const VIETNAMESE_CHARSET = 163
Const THAI_CHARSET = 222
Const EASTEUROPE_CHARSET = 238
Const RUSSIAN_CHARSET = 204
Const MAC_CHARSET = 77
Const BALTIC_CHARSET = 186

'fdwOutputPrecision constants
Const OUT_DEFAULT_PRECIS = 0
Const OUT_STRING_PRECIS = 1
Const OUT_CHARACTER_PRECIS = 2
Const OUT_STROKE_PRECIS = 3
Const OUT_TT_PRECIS = 4
Const OUT_DEVICE_PRECIS = 5
Const OUT_RASTER_PRECIS = 6
Const OUT_TT_ONLY_PRECIS = 7
Const OUT_OUTLINE_PRECIS = 8
Const OUT_SCREEN_OUTLINE_PRECIS = 9

'fdwClipPrecision
Const CLIP_DEFAULT_PRECIS = 0
Const CLIP_CHARACTER_PRECIS = 1
Const CLIP_STROKE_PRECIS = 2
Const CLIP_MASK = 15
Const CLIP_LH_ANGLES = 16
Const CLIP_TT_ALWAYS = 32
Const CLIP_EMBEDDED = 128

'fdwQuality constants
Const DEFAULT_QUALITY = 0
Const DRAFT_QUALITY = 1
Const PROOF_QUALITY = 2
Const NONANTIALIASED_QUALITY = 3
Const ANTIALIASED_QUALITY = 4

'fdwPitchAndFamily - low-order
Const DEFAULT_PITCH = 0
Const FIXED_PITCH = 1
Const VARIABLE_PITCH = 2

'fdwPitchAndFamily - high-order
Const FF_DONTCARE = 0
Const FF_ROMAN = 16
Const FF_SWISS = 32
Const FF_MODERN = 48
Const FF_SCRIPT = 64
Const FF_DECORATIVE = 80

'Default Property Values:
Const m_def_CaptionMarginX = 0
Const m_def_CaptionMarginY = 0
Const m_def_PixelWidth = 0
Const m_def_PixelHeight = 0
Const m_def_FontSize = 10
Const m_def_CaptionBegin = 0
Const m_def_CaptionBeginX = 0
Const m_def_CaptionBeginY = 0
Const m_def_Caption = ""
Const m_def_FontName = "Arial"
Const m_def_FontItalic = False
Const m_def_FontUnderline = False
Const m_def_FontStrikeOut = False
Const m_def_FontRotation = 0
Const m_def_FontAntiAliased = False
Const m_def_FontColor = 0
Const m_def_FontWeight = 400
Const m_def_FontHeight = 0

'Property Variables:
Dim m_CaptionMarginX As Long
Dim m_CaptionMarginY As Long
Dim m_PixelWidth As Long
Dim m_PixelHeight As Long
Dim m_CaptionBegin As ETBCaptionBegin
Dim m_CaptionBeginX As Long
Dim m_CaptionBeginY As Long
Dim m_Caption As String
Dim m_FontName As String
Dim m_FontColor As OLE_COLOR
Dim m_FontItalic As Boolean
Dim m_FontUnderline As Boolean
Dim m_FontStrikeOut As Boolean
Dim m_FontRotation As Single
Dim m_FontSize As Long
Dim m_FontWeight As Long
Dim m_FontAntiAliased As Boolean
Private Sub BeginFRDrag(X As Single, Y As Single)
    
With Parent
    Dim tDc As Long
    Dim sDc As Long
    Dim d As Long
   
   'convert points to POINTAPI struct
    dpoint.X = X
    dpoint.Y = Y
   
   'get screen area of toolbar
    GetWindowRect .hwnd, fbox     'screen Rect of toolbar
    TwipsPerPixelX = Screen.TwipsPerPixelX
    TwipsPerPixelY = Screen.TwipsPerPixelY
   
   'get point of mousedown in screen coordinates
    Temp = dpoint
    ClientToScreen .hwnd, Temp

    sDc = GetDC(ByVal 0)
    DrawFocusRect sDc, tbox
    d = ReleaseDC(0, sDc)
    oldbox = tbox
End With

End Sub
Private Sub DoFRDrag(X As Single, Y As Single)

With Parent
    Dim tDc As Long
    Dim sDc As Long
    Dim d As Long
    
    tpoint.X = X
    tpoint.Y = Y

    ClientToScreen .hwnd, tpoint

    tbox.Left = (fbox.Left + tpoint.X / TwipsPerPixelX) - Temp.X / TwipsPerPixelX
    tbox.Top = (fbox.Top + tpoint.Y / TwipsPerPixelY) - Temp.Y / TwipsPerPixelY
    tbox.Right = (fbox.Right + tpoint.X / TwipsPerPixelX) - Temp.X / TwipsPerPixelX
    tbox.Bottom = (fbox.Bottom + tpoint.Y / TwipsPerPixelY) - Temp.Y / TwipsPerPixelY

    sDc = GetDC(ByVal 0)
    DrawFocusRect sDc, oldbox
    DrawFocusRect sDc, tbox
    d = ReleaseDC(0, sDc)
    oldbox = tbox
End With

End Sub
Private Sub EndFRDrag(X As Single, Y As Single)

    Dim tDc As Long
    Dim sDc As Long
    Dim d As Long
    
    Dim newleft As Single
    Dim newtop As Single

    sDc = GetDC(ByVal 0)
    DrawFocusRect sDc, oldbox
    d = ReleaseDC(0, sDc)

    newleft = X + fbox.Left * TwipsPerPixelX - dpoint.X
    newtop = Y + fbox.Top * TwipsPerPixelY - dpoint.Y
    
    Parent.Move newleft, newtop

End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"
    Repaint
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = UserControl.Enabled
End Property
Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackStyle
Public Property Get BackStyle() As Integer
Attribute BackStyle.VB_Description = "Indicates whether a Label or the background of a Shape is transparent or opaque."
    BackStyle = UserControl.BackStyle
End Property
Public Property Let BackStyle(ByVal New_BackStyle As Integer)
    UserControl.BackStyle() = New_BackStyle
    PropertyChanged "BackStyle"
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BorderStyle
Public Property Get BorderStyle() As Integer
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
    BorderStyle = UserControl.BorderStyle
End Property
Public Property Let BorderStyle(ByVal New_BorderStyle As Integer)
    UserControl.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property
Private Sub GetCurrentXY(ByRef X As Single, ByRef Y As Single)
    Dim p As POINTAPI
    GetCursorPos p
    X = CSng(ScaleX(p.X, vbPixels, vbTwips))
    Y = CSng(ScaleY(p.Y, vbPixels, vbTwips))
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Refresh
Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
    UserControl.Refresh
End Sub
Private Sub Repaint()
    Cls
    
    'set text color
    SetTextColor hdc, m_FontColor
    
    'create font
    Dim hFont As Long
    
    Dim nHeight As Long, fdwItalic As Long, fdwUnderline As Long, fdwStrike As Long, fdwQuality As Long
    nHeight = -MulDiv(m_FontSize, GetDeviceCaps(hdc, LOGPIXELSY), 72)
    fdwItalic = -m_FontItalic   'for some reason, VB TRUE = -1
    fdwUnderline = -m_FontUnderline
    fdwStrike = m_FontStrikeOut
    fdwQuality = IIf(m_FontAntiAliased, ANTIALIASED_QUALITY, 0)
    
    hFont = CreateFont(nHeight, 0, m_FontRotation * 10, m_FontRotation * 10, m_FontWeight, fdwItalic, fdwUnderline, fdwStrike, 0, 0, 0, fdwQuality, 0, m_FontName)
        
    SelectObject hdc, hFont
    
    'print
    TextOut hdc, m_CaptionBeginX, m_CaptionBeginY, m_Caption, Len(m_Caption)
    
    'cleanup
    DeleteObject hFont
    
End Sub
Private Sub SetCaptionBeginXY()
Dim deg As Integer
deg = (m_FontRotation Mod 360)

'Rotation: (x,y)
'  0   (0, 0)
'  90  (0,Height)
'  180 (Width, Height)
'  270 (Width,0)

Select Case deg
    Case 0
        m_CaptionBeginX = m_CaptionMarginX
        m_CaptionBeginY = m_CaptionMarginY
    Case 90
        m_CaptionBeginX = m_CaptionMarginX
        m_CaptionBeginY = PixelHeight - m_CaptionMarginY
    Case 180
        m_CaptionBeginX = PixelWidth - m_CaptionMarginX
        m_CaptionBeginY = PixelHeight - m_CaptionMarginY
    Case 270
        m_CaptionBeginX = PixelWidth - m_CaptionMarginX
        m_CaptionBeginY = m_CaptionMarginY
End Select

PropertyChanged "CaptionBeginX"
PropertyChanged "CaptionBeginY"

Repaint
End Sub
Private Sub UserControl_Click()
    RaiseEvent Click
End Sub
Private Sub UserControl_DblClick()
    RaiseEvent DblClick
End Sub
Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
    If Button = vbLeftButton Then BeginFRDrag X, Y
End Sub
Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
    If Button = vbLeftButton Then DoFRDrag X, Y
End Sub
Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
    If Button = vbLeftButton Then EndFRDrag X, Y
End Sub
Private Sub UserControl_Paint()
    Repaint
End Sub
'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    UserControl.BackStyle = PropBag.ReadProperty("BackStyle", 1)
    UserControl.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
    m_Caption = PropBag.ReadProperty("Caption", m_def_Caption)
    m_FontName = PropBag.ReadProperty("FontName", m_def_FontName)
    m_FontItalic = PropBag.ReadProperty("FontItalic", m_def_FontItalic)
    m_FontUnderline = PropBag.ReadProperty("FontUnderline", m_def_FontUnderline)
    m_FontStrikeOut = PropBag.ReadProperty("FontStrikeOut", m_def_FontStrikeOut)
    m_FontRotation = PropBag.ReadProperty("FontRotation", m_def_FontRotation)
    m_FontWeight = PropBag.ReadProperty("FontWeight", m_def_FontWeight)
    m_FontAntiAliased = PropBag.ReadProperty("FontAntiAliased", m_def_FontAntiAliased)
    m_CaptionBeginX = PropBag.ReadProperty("CaptionBeginX", m_def_CaptionBeginX)
    m_CaptionBeginY = PropBag.ReadProperty("CaptionBeginY", m_def_CaptionBeginY)
    m_FontSize = PropBag.ReadProperty("FontSize", m_def_FontSize)
    m_PixelHeight = PropBag.ReadProperty("PixelHeight", m_def_PixelHeight)
    m_PixelWidth = PropBag.ReadProperty("PixelWidth", m_def_PixelWidth)
    m_FontColor = PropBag.ReadProperty("FontColor", m_def_FontColor)
    m_CaptionBegin = PropBag.ReadProperty("CaptionBegin", m_def_CaptionBegin)
    m_CaptionMarginX = PropBag.ReadProperty("CaptionMarginX", m_def_CaptionMarginX)
    m_CaptionMarginY = PropBag.ReadProperty("CaptionMarginY", m_def_CaptionMarginY)
End Sub

Private Sub UserControl_Resize()
    RaiseEvent Resize
    PixelHeight = ScaleY(Height, vbTwips, vbPixels)
    PixelWidth = ScaleX(Width, vbTwips, vbPixels)
    If m_CaptionBegin = etbcb_Automatic Then SetCaptionBeginXY
End Sub
'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("BackStyle", UserControl.BackStyle, 1)
    Call PropBag.WriteProperty("BorderStyle", UserControl.BorderStyle, 0)
    Call PropBag.WriteProperty("Caption", m_Caption, m_def_Caption)
    Call PropBag.WriteProperty("FontName", m_FontName, m_def_FontName)
    Call PropBag.WriteProperty("FontItalic", m_FontItalic, m_def_FontItalic)
    Call PropBag.WriteProperty("FontUnderline", m_FontUnderline, m_def_FontUnderline)
    Call PropBag.WriteProperty("FontStrikeOut", m_FontStrikeOut, m_def_FontStrikeOut)
    Call PropBag.WriteProperty("FontRotation", m_FontRotation, m_def_FontRotation)
    Call PropBag.WriteProperty("FontWeight", m_FontWeight, m_def_FontWeight)
    Call PropBag.WriteProperty("FontAntiAliased", m_FontAntiAliased, m_def_FontAntiAliased)
    Call PropBag.WriteProperty("CaptionBeginX", m_CaptionBeginX, m_def_CaptionBeginX)
    Call PropBag.WriteProperty("CaptionBeginY", m_CaptionBeginY, m_def_CaptionBeginY)
    Call PropBag.WriteProperty("FontSize", m_FontSize, m_def_FontSize)
    Call PropBag.WriteProperty("PixelHeight", m_PixelHeight, m_def_PixelHeight)
    Call PropBag.WriteProperty("PixelWidth", m_PixelWidth, m_def_PixelWidth)
    Call PropBag.WriteProperty("FontColor", m_FontColor, m_def_FontColor)
    Call PropBag.WriteProperty("CaptionBegin", m_CaptionBegin, m_def_CaptionBegin)
    Call PropBag.WriteProperty("CaptionMarginX", m_CaptionMarginX, m_def_CaptionMarginX)
    Call PropBag.WriteProperty("CaptionMarginY", m_CaptionMarginY, m_def_CaptionMarginY)
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,0,0,
Public Property Get Caption() As String
    Caption = m_Caption
End Property
Public Property Let Caption(ByVal New_Caption As String)
    m_Caption = New_Caption
    PropertyChanged "Caption"
    Repaint
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=5
Public Sub EndDrag()
    Dim X As Single, Y As Single
    GetCurrentXY X, Y
    EndFRDrag X, Y
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=5
Public Sub DoDrag()
    Dim X As Single, Y As Single
    GetCurrentXY X, Y
    DoFRDrag X, Y
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=5
Public Sub BeginDrag()
    Dim X As Single, Y As Single
    GetCurrentXY X, Y
    BeginFRDrag X, Y
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,0,0,Arial
Public Property Get FontName() As String
    FontName = m_FontName
End Property
Public Property Let FontName(ByVal New_FontName As String)
    m_FontName = New_FontName
    PropertyChanged "FontName"
    Repaint
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,False
Public Property Get FontItalic() As Boolean
    FontItalic = m_FontItalic
End Property
Public Property Let FontItalic(ByVal New_FontItalic As Boolean)
    m_FontItalic = New_FontItalic
    PropertyChanged "FontItalic"
    Repaint
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,False
Public Property Get FontUnderline() As Boolean
    FontUnderline = m_FontUnderline
End Property
Public Property Let FontUnderline(ByVal New_FontUnderline As Boolean)
    m_FontUnderline = New_FontUnderline
    PropertyChanged "FontUnderline"
    Repaint
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,False
Public Property Get FontStrikeOut() As Boolean
    FontStrikeOut = m_FontStrikeOut
End Property
Public Property Let FontStrikeOut(ByVal New_FontStrikeOut As Boolean)
    m_FontStrikeOut = New_FontStrikeOut
    PropertyChanged "FontStrikeOut"
    Repaint
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=12,0,0,0
Public Property Get FontRotation() As Single
    FontRotation = m_FontRotation
End Property
Public Property Let FontRotation(ByVal New_FontRotation As Single)
    m_FontRotation = New_FontRotation
    PropertyChanged "FontRotation"
    
    If m_CaptionBegin = etbcb_Automatic Then SetCaptionBeginXY
    
    Repaint
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,0,0,10
Public Property Get FontWeight() As Long
    FontWeight = m_FontWeight
End Property
Public Property Let FontWeight(ByVal New_FontWeight As Long)
    m_FontWeight = New_FontWeight
    PropertyChanged "FontWeight"
    Repaint
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,False
Public Property Get FontAntiAliased() As Boolean
    FontAntiAliased = m_FontAntiAliased
End Property
Public Property Let FontAntiAliased(ByVal New_FontAntiAliased As Boolean)
    m_FontAntiAliased = New_FontAntiAliased
    PropertyChanged "FontAntiAliased"
    Repaint
End Property
'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_Caption = m_def_Caption
    m_FontName = m_def_FontName
    m_FontItalic = m_def_FontItalic
    m_FontUnderline = m_def_FontUnderline
    m_FontStrikeOut = m_def_FontStrikeOut
    m_FontRotation = m_def_FontRotation
    m_FontWeight = m_def_FontWeight
    m_FontAntiAliased = m_def_FontAntiAliased
    m_CaptionBeginX = m_def_CaptionBeginX
    m_CaptionBeginY = m_def_CaptionBeginY
    m_FontSize = m_def_FontSize
    m_PixelHeight = m_def_PixelHeight
    m_PixelWidth = m_def_PixelWidth
    m_FontColor = m_def_FontColor
    m_CaptionBegin = m_def_CaptionBegin
    m_CaptionMarginX = m_def_CaptionMarginX
    m_CaptionMarginY = m_def_CaptionMarginY
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,0,0,0
Public Property Get CaptionBeginX() As Long
    CaptionBeginX = m_CaptionBeginX
End Property
Public Property Let CaptionBeginX(ByVal New_CaptionBeginX As Long)
    m_CaptionBeginX = New_CaptionBeginX
    PropertyChanged "CaptionBeginX"
    
    If m_CaptionBegin = etbcb_Automatic Then
        m_CaptionBegin = etbcb_Manual
        PropertyChanged "CaptionBegin"
    End If
    
    Repaint
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,0,0,0
Public Property Get CaptionBeginY() As Long
    CaptionBeginY = m_CaptionBeginY
End Property
Public Property Let CaptionBeginY(ByVal New_CaptionBeginY As Long)
    m_CaptionBeginY = New_CaptionBeginY
    PropertyChanged "CaptionBeginY"
    
    If m_CaptionBegin = etbcb_Automatic Then
        m_CaptionBegin = etbcb_Manual
        PropertyChanged "CaptionBegin"
    End If
    
    Repaint
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,0,0,10
Public Property Get FontSize() As Long
    FontSize = m_FontSize
End Property
Public Property Let FontSize(ByVal New_FontSize As Long)
    m_FontSize = New_FontSize
    PropertyChanged "FontSize"
    PropertyChanged "FontHeight"
    Repaint
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,0,0,0
Public Property Get PixelHeight() As Long
    PixelHeight = m_PixelHeight
End Property
Public Property Let PixelHeight(ByVal New_PixelHeight As Long)
    m_PixelHeight = New_PixelHeight
    PropertyChanged "PixelHeight"
    Height = ScaleX(New_PixelHeight, vbPixels, vbTwips)
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,0,0,0
Public Property Get PixelWidth() As Long
    PixelWidth = m_PixelWidth
End Property
Public Property Let PixelWidth(ByVal New_PixelWidth As Long)
    m_PixelWidth = New_PixelWidth
    PropertyChanged "PixelWidth"
    Width = ScaleX(New_PixelWidth, vbPixels, vbTwips)
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,1,1,0
Public Property Get FontHeight() As Long
    FontHeight = MulDiv(m_FontSize, GetDeviceCaps(hdc, LOGPIXELSY), 72)
End Property
Public Property Let FontHeight(ByVal New_FontHeight As Long)
    If Ambient.UserMode Then Err.Raise 382
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get FontColor() As OLE_COLOR
    FontColor = m_FontColor
End Property
Public Property Let FontColor(ByVal New_FontColor As OLE_COLOR)
    m_FontColor = New_FontColor
    PropertyChanged "FontColor"
    Repaint
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,1
Public Property Get CaptionBegin() As ETBCaptionBegin
    CaptionBegin = m_CaptionBegin
End Property
Public Property Let CaptionBegin(ByVal New_CaptionBegin As ETBCaptionBegin)
    m_CaptionBegin = New_CaptionBegin
    PropertyChanged "CaptionBegin"
    
    If m_CaptionBegin = etbcb_Automatic Then SetCaptionBeginXY
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,0,0,0
Public Property Get CaptionMarginX() As Long
    CaptionMarginX = m_CaptionMarginX
End Property

Public Property Let CaptionMarginX(ByVal New_CaptionMarginX As Long)
    m_CaptionMarginX = New_CaptionMarginX
    PropertyChanged "CaptionMarginX"
    
    If m_CaptionBegin = etbcb_Automatic Then SetCaptionBeginXY
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,0,0,0
Public Property Get CaptionMarginY() As Long
    CaptionMarginY = m_CaptionMarginY
End Property

Public Property Let CaptionMarginY(ByVal New_CaptionMarginY As Long)
    m_CaptionMarginY = New_CaptionMarginY
    PropertyChanged "CaptionMarginY"
    
    If m_CaptionBegin = etbcb_Automatic Then SetCaptionBeginXY
End Property
